linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: "Paul E. McKenney" <paulmck@linux.ibm.com>
To: linux-kernel@vger.kernel.org, linux-arch@vger.kernel.org,
	mingo@kernel.org
Cc: stern@rowland.harvard.edu, andrea.parri@amarulasolutions.com,
	will@kernel.org, peterz@infradead.org, boqun.feng@gmail.com,
	npiggin@gmail.com, dhowells@redhat.com, j.alglave@ucl.ac.uk,
	luc.maranget@inria.fr, akiyks@gmail.com,
	"Paul E. McKenney" <paulmck@linux.ibm.com>
Subject: [PATCH RFC memory-model 14/31] tools/memory-model: Make runlitmus.sh generate .litmus.out for --hw
Date: Thu,  1 Aug 2019 15:20:39 -0700	[thread overview]
Message-ID: <20190801222056.12144-14-paulmck@linux.ibm.com> (raw)
In-Reply-To: <20190801222026.GA11315@linux.ibm.com>

In the absence of "Result:" comments, the runlitmus.sh script relies on
litmus.out files from prior LKMM runs.  This can be a bit user-hostile,
so this commit makes runlitmus.sh generate any needed .litmus.out files
that don't already exist.

Signed-off-by: Paul E. McKenney <paulmck@linux.ibm.com>
---
 tools/memory-model/scripts/runlitmus.sh | 54 ++++++++++++++-----------
 1 file changed, 30 insertions(+), 24 deletions(-)

diff --git a/tools/memory-model/scripts/runlitmus.sh b/tools/memory-model/scripts/runlitmus.sh
index 91af859c0e90..2865a9661b07 100755
--- a/tools/memory-model/scripts/runlitmus.sh
+++ b/tools/memory-model/scripts/runlitmus.sh
@@ -28,42 +28,48 @@ if test -f "$litmus" -a -r "$litmus"
 then
 	:
 else
-	echo ' --- ' error: \"$litmus\" is not a readable file
+	echo ' !!! ' error: \"$litmus\" is not a readable file
 	exit 255
 fi
 
-if test -z "$LKMM_HW_MAP_FILE"
+if test -z "$LKMM_HW_MAP_FILE" -o ! -e $LKMM_DESTDIR/$litmus.out
 then
 	# LKMM run
 	herdoptions=${LKMM_HERD_OPTIONS--conf linux-kernel.cfg}
 	echo Herd options: $herdoptions > $LKMM_DESTDIR/$litmus.out
 	/usr/bin/time $LKMM_TIMEOUT_CMD herd7 $herdoptions $litmus >> $LKMM_DESTDIR/$litmus.out 2>&1
-else
-	# Hardware run
+	ret=$?
+	if test -z "$LKMM_HW_MAP_FILE"
+	then
+		exit $ret
+	fi
+	echo " --- " Automatically generated LKMM output for '"'--hw $LKMM_HW_MAP_FILE'"' run
+fi
 
-	T=/tmp/checklitmushw.sh.$$
-	trap 'rm -rf $T' 0 2
-	mkdir $T
+# Hardware run
 
-	# Generate filenames
-	catfile="`echo $LKMM_HW_MAP_FILE | tr '[A-Z]' '[a-z]'`.cat"
-	mapfile="Linux2${LKMM_HW_MAP_FILE}.map"
-	themefile="$T/${LKMM_HW_MAP_FILE}.theme"
-	herdoptions="-model $LKMM_HW_CAT_FILE"
-	hwlitmus=`echo $litmus | sed -e 's/\.litmus$/.'${LKMM_HW_MAP_FILE}'.litmus/'`
-	hwlitmusfile=`echo $hwlitmus | sed -e 's,^.*/,,'`
+T=/tmp/checklitmushw.sh.$$
+trap 'rm -rf $T' 0 2
+mkdir $T
 
-	# Don't run on litmus tests with complex synchronization
-	if ! scripts/simpletest.sh $litmus
-	then
-		echo ' --- ' error: \"$litmus\" contains locking, RCU, or SRCU
-		exit 254
-	fi
+# Generate filenames
+catfile="`echo $LKMM_HW_MAP_FILE | tr '[A-Z]' '[a-z]'`.cat"
+mapfile="Linux2${LKMM_HW_MAP_FILE}.map"
+themefile="$T/${LKMM_HW_MAP_FILE}.theme"
+herdoptions="-model $LKMM_HW_CAT_FILE"
+hwlitmus=`echo $litmus | sed -e 's/\.litmus$/.'${LKMM_HW_MAP_FILE}'.litmus/'`
+hwlitmusfile=`echo $hwlitmus | sed -e 's,^.*/,,'`
 
-	# Generate the assembly code and run herd on it.
-	gen_theme7 -n 10 -map $mapfile -call Linux.call > $themefile
-	jingle7 -theme $themefile $litmus > $T/$hwlitmusfile 2> $T/$hwlitmusfile.jingle7.out
-	/usr/bin/time $LKMM_TIMEOUT_CMD herd7 -model $catfile $T/$hwlitmusfile > $LKMM_DESTDIR/$hwlitmus.out 2>&1
+# Don't run on litmus tests with complex synchronization
+if ! scripts/simpletest.sh $litmus
+then
+	echo ' --- ' error: \"$litmus\" contains locking, RCU, or SRCU
+	exit 254
 fi
 
+# Generate the assembly code and run herd7 on it.
+gen_theme7 -n 10 -map $mapfile -call Linux.call > $themefile
+jingle7 -theme $themefile $litmus > $T/$hwlitmusfile 2> $T/$hwlitmusfile.jingle7.out
+/usr/bin/time $LKMM_TIMEOUT_CMD herd7 -model $catfile $T/$hwlitmusfile > $LKMM_DESTDIR/$hwlitmus.out 2>&1
+
 exit $?
-- 
2.17.1


  parent reply	other threads:[~2019-08-01 22:21 UTC|newest]

Thread overview: 38+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-08-01 22:20 [PATCH RFC memory-model 0/31] LKMM updates for review Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 01/31] tools/memory-model: Make scripts be executable Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 02/31] tools/memory-model: Make judgelitmus.sh note timeouts Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 03/31] tools/memory-model: Make cmplitmushist.sh " Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 04/31] tools/memory-model: Make judgelitmus.sh identify bad macros Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 05/31] tools/memory-model: Make judgelitmus.sh detect hard deadlocks Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 06/31] tools/memory-model: Fix paulmck email address on pre-existing scripts Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 07/31] tools/memory-model: Update parseargs.sh for hardware verification Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 08/31] tools/memory-model: Make judgelitmus.sh handle hardware verifications Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 09/31] tools/memory-model: Add simpletest.sh to check locking, RCU, and SRCU Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 10/31] tools/memory-model: Fix checkalllitmus.sh comment Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 11/31] tools/memory-model: Hardware checking for check{,all}litmus.sh Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 12/31] tools/memory-model: Make judgelitmus.sh ransack .litmus.out files Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 13/31] tools/memory-model: Split runlitmus.sh out of checklitmus.sh Paul E. McKenney
2019-08-01 22:20 ` Paul E. McKenney [this message]
2019-08-01 22:20 ` [PATCH RFC memory-model 15/31] tools/memory-model: Move from .AArch64.litmus.out to .litmus.AArch.out Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 16/31] tools/memory-model: Keep assembly-language litmus tests Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 17/31] tools/memory-model: Allow herd to deduce CPU type Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 18/31] tools/memory-model: Make runlitmus.sh check for jingle errors Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 19/31] tools/memory-model: Add -v flag to jingle7 runs Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 20/31] tools/memory-model: Implement --hw support for checkghlitmus.sh Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 21/31] tools/memory-model: Fix scripting --jobs argument Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 22/31] tools/memory-model: Make checkghlitmus.sh use mselect7 Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 23/31] tools/memory-model: Make history-check scripts " Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 24/31] tools/memory-model: Add "--" to parseargs.sh for additional arguments Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 25/31] tools/memory-model: Repair parseargs.sh header comment Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 26/31] tools/memory-model: Add checktheselitmus.sh to run specified litmus tests Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 27/31] tools/memory-model: Add data-race capabilities to judgelitmus.sh Paul E. McKenney
2019-08-12 14:32   ` Akira Yokosawa
2019-08-12 18:06     ` Paul E. McKenney
2019-08-14 15:11       ` [PATCH 0/2] tools/memory-model: Update comment of jugdelitmus.sh Akira Yokosawa
2019-08-14 15:13         ` Subject: [PATCH 1/2] tools/memory-model: Reflect updated file name convention in judgelitmus.sh Akira Yokosawa
2019-08-14 15:16         ` [PATCH 2/2] tools/memory-model: Mention data-race capability in jugdelitmus.sh's header Akira Yokosawa
2019-08-14 23:24         ` [PATCH 0/2] tools/memory-model: Update comment of jugdelitmus.sh Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 28/31] tools/memory-model: Make judgelitmus.sh handle scripted Result: tag Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 29/31] tools/memory-model: Use "-unroll 0" to keep --hw runs finite Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 30/31] tools/memory-model: Use cumul-fence instead of fence in ->prop example Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 31/31] tools/memory-model: Update the informal documentation Paul E. McKenney

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20190801222056.12144-14-paulmck@linux.ibm.com \
    --to=paulmck@linux.ibm.com \
    --cc=akiyks@gmail.com \
    --cc=andrea.parri@amarulasolutions.com \
    --cc=boqun.feng@gmail.com \
    --cc=dhowells@redhat.com \
    --cc=j.alglave@ucl.ac.uk \
    --cc=linux-arch@vger.kernel.org \
    --cc=linux-kernel@vger.kernel.org \
    --cc=luc.maranget@inria.fr \
    --cc=mingo@kernel.org \
    --cc=npiggin@gmail.com \
    --cc=peterz@infradead.org \
    --cc=stern@rowland.harvard.edu \
    --cc=will@kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).